/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef L2_CACHE_UTILIZATION_TEST_H
#define L2_CACHE_UTILIZATION_TEST_H

#include <string>
#include "PerformanceTest.h"

namespace advisor
{
class L2CacheUtilizationPerformanceTest : public PerformanceTest
{
private:
    cube::Metric*      l2_utilization;
    static std::string l2_not_measured;
protected:
    void
    applyCnode( const cube::list_of_cnodes& cnodes   );

    void
    applyCnode( const cube::Cnode*             cnode,
                const cube::CalculationFlavour cnf = cube::CUBE_CALCULATE_INCLUSIVE );

    virtual
    const std::string&
    getCommentText() const;

    inline
    virtual
    const
    QString
    getHelpUrl()
    {
        return ( isActive() ) ?
               QString::fromStdString( "L2CachePerformanceTest" ) :
               QString::fromStdString( "MissingL2CachePerformanceTest" );
    }

public:
    L2CacheUtilizationPerformanceTest( cube::CubeProxy* );

    virtual
    ~L2CacheUtilizationPerformanceTest()
    {
    };
// ------ overview tests ---------

    bool
    isActive() const;

    bool
    isIssue() const;
};
};
#endif // ADVISER_RATING_WIDGET_H
