/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef ALGORITHM_MANAMEGENT_PERFORMANCE_TEST_H
#define ALGORITHM_MANAMEGENT_PERFORMANCE_TEST_H

#include <string>
#include "PerformanceTest.h"

namespace advisor
{
class AlgMgmtTest : public PerformanceTest
{
private:
    cube::Metric* management;
    cube::Metric* sync;
    cube::Metric* execution;

    static std::string comment_poor;
    static std::string comment_significant;
    static std::string comment_some;
    static std::string comment_notime;

protected:

    void
    applyCnode( const cube::list_of_cnodes& cnodes   );

    void
    applyCnode( const cube::Cnode*             cnode,
                const cube::CalculationFlavour cnf = cube::CUBE_CALCULATE_INCLUSIVE );

    virtual
    const std::string&
    getCommentText() const;

    inline
    const
    QString
    getHelpUrl()
    {
        return ( isActive() ) ?
               QString::fromStdString( "AlgMgmtTest" ) :
               QString::fromStdString( "MissingAlgMgmtTest" );
    }

public:
    AlgMgmtTest( cube::CubeProxy* );

    virtual
    ~AlgMgmtTest()
    {
    };

// ------ overview tests ---------

    bool
    isActive() const;

    bool
    isIssue() const;
};
};
#endif // ADVISER_RATING_WIDGET_H
